package com.jiuqi.syntax;

package .tmp;

import com.jiuqi.syntax.CommonData;
import com.jiuqi.syntax.DataCell;

public final class NiporlanItem implements Cloneable {
  public static int NI_NEW_COUNT = 0;
  
  public static int NI_LIVE_COUNT = 0;
  
  public static final int OP_TYPE = 0;
  
  public static final int FUNC_TYPE = 1;
  
  public static final int DATA_TYPE = 2;
  
  public static final int CELL_TYPE = 3;
  
  public static final int OBJECT_TYPE = 4;
  
  protected void finalize() throws Throwable {
    NI_LIVE_COUNT--;
    super.finalize();
  }
  
  private int type = 0;
  
  private int op = 14;
  
  private String funcName = null;
  
  private CommonData commonData = null;
  
  private DataCell dataCell = null;
  
  private Object object = null;
  
  private Object dataLocator = null;
  
  public int getType() {
    return this.type;
  }
  
  public void setType(int type) {
    this.type = type;
  }
  
  public int getOp() {
    return this.op;
  }
  
  public void setOp(int op) {
    this.op = op;
  }
  
  public String getFuncName() {
    if (this.funcName == null)
      return ""; 
    return this.funcName;
  }
  
  public void setFuncName(String funcName) {
    this.funcName = funcName;
  }
  
  public CommonData getCommonData() {
    if (this.commonData == null)
      this.commonData = new CommonData(); 
    return this.commonData;
  }
  
  public void setCommonData(CommonData commonData) {
    getCommonData().assign(commonData);
  }
  
  public DataCell getDataCell() {
    if (this.dataCell == null)
      this.dataCell = new DataCell(); 
    return this.dataCell;
  }
  
  public void setDataCell(DataCell dataCell) {
    getDataCell().assign(dataCell);
  }
  
  public Object getObject() {
    return this.object;
  }
  
  public void setObject(Object object) {
    this.object = object;
  }
  
  public Object getDataLocator() {
    return this.dataLocator;
  }
  
  public void setDataLocator(Object value) {
    this.dataLocator = value;
  }
  
  public void setValue(int op) {
    setType(0);
    setOp(op);
  }
  
  public void setValue(String funcName) {
    setType(1);
    setFuncName(funcName);
  }
  
  public void setValue(CommonData commonData) {
    setType(2);
    setCommonData(commonData);
  }
  
  public void setValue(DataCell dataCell) {
    setType(3);
    setDataCell(dataCell);
  }
  
  public void setValue(Object object) {
    setType(4);
    setObject(object);
  }
  
  public NiporlanItem() {
    NI_NEW_COUNT++;
    NI_LIVE_COUNT++;
  }
  
  public NiporlanItem(int op) {
    NI_NEW_COUNT++;
    NI_LIVE_COUNT++;
    setValue(op);
  }
  
  public NiporlanItem(String funcName) {
    NI_NEW_COUNT++;
    NI_LIVE_COUNT++;
    setValue(funcName);
  }
  
  public NiporlanItem(CommonData commonData) {
    NI_NEW_COUNT++;
    NI_LIVE_COUNT++;
    setValue(commonData);
  }
  
  public NiporlanItem(DataCell dataCell) {
    NI_NEW_COUNT++;
    NI_LIVE_COUNT++;
    setValue(dataCell);
  }
  
  public NiporlanItem(Object object) {
    NI_NEW_COUNT++;
    NI_LIVE_COUNT++;
    setValue(object);
  }
  
  public void assign(com.jiuqi.syntax.NiporlanItem source) {
    this.type = source.type;
    this.op = source.op;
    this.funcName = source.funcName;
    if (source.commonData != null) {
      if (this.commonData == null)
        this.commonData = new CommonData(); 
      this.commonData.assign(source.commonData);
    } 
    if (source.dataCell != null) {
      if (this.dataCell == null)
        this.dataCell = new DataCell(); 
      this.dataCell.assign(source.dataCell);
    } 
    this.object = source.object;
    this.dataLocator = source.dataLocator;
  }
}
